#setwd("C:/Users/idlew/Documents/Courses/ES")
setwd("/Users/patrickboily/Dropbox/Apps/ShareLaTeX/uOttawa - Teaching/Current/mat3777-2022")
library(tidyverse)

gapminder = read.csv("Data/gapminder.csv")
str(gapminder)

####### Population Quotient
gapminder.QRD <- gapminder %>%
  filter(year==2011) %>%
  select(life_expectancy,gdp,population)

gapminder.QRD <- gapminder.QRD[complete.cases(gapminder.QRD),]

N=nrow(gapminder.QRD)

gapminder.QRD <- gapminder.QRD %>%
  mutate(lgdppc=log(gdp/population))

ggplot(gapminder.QRD,aes(x=lgdppc,y=life_expectancy)) + 
  geom_point() + theme_bw() + ylim(0,85)

mean(gapminder.QRD$life_expectancy)
mean(gapminder.QRD$lgdppc)

mean(gapminder.QRD$life_expectancy)/mean(gapminder.QRD$lgdppc)

index = c(65,91,164,72,77,75,165,123,90,36)
ech = gapminder.QRD[index,c("life_expectancy","lgdppc")]
mean(ech$life_expectancy/ech$lgdppc)

# 500 échantillons de taille 10
set.seed(12)
N=dim(gapminder.QRD)[1]
n=20
m=500
quotients <- c()
for(k in 1:m){
  ech <- gapminder.QRD[sample(1:N,n, replace=FALSE),c("life_expectancy","lgdppc")]
  quotients[k] <- mean(ech$life_expectancy/ech$lgdppc)
}

ggplot(data.frame(quotients), aes(quotients)) + 
  geom_histogram(breaks=seq(8, 10.5, by = .125), 
                 col="black", fill="blue", alpha=.2) + 
  geom_density(col=2) + geom_rug(aes(quotients)) 

# intervalle de confiance
gapminder.QRD <- gapminder %>%
  filter(year==2011) %>%
  select(life_expectancy,gdp,population)

gapminder.QRD <- gapminder.QRD[complete.cases(gapminder.QRD),]

N=nrow(gapminder.QRD)
gapminder.QRD <- gapminder.QRD %>% mutate(lgdppc=log(gdp/population))

(R = mean(gapminder.QRD$life_expectancy)/mean(gapminder.QRD$lgdppc))

# echantillon de taille 20 
n=20
set.seed(123456)
index = sample(1:N,n, replace=FALSE)
ech = gapminder.QRD[index,c("life_expectancy","lgdppc")]
mean(ech$life_expectancy/ech$lgdppc)

(somme.xi = sum(ech$lgdppc))
(somme.yi = sum(ech$life_expectancy))
(somme.xi.2 = sum(ech$lgdppc^2))
(somme.yi.2 = sum(ech$life_expectancy^2))
(somme.xiyi = sum(ech$lgdppc*ech$life_expectancy))

(r = somme.yi/somme.xi)
(s2.W = 1/(n-1)*(somme.yi.2-2*r*somme.xiyi+r^2*somme.xi.2))
(V = n^2/somme.xi^2*(1/n)*s2.W*(1-n/N))
(B = 2*sqrt(V))
r+B
r-B


####### Population Regression
(mu.X = mean(gapminder.QRD[,"lgdppc"]))
(mu.Y = mean(gapminder.QRD[,"life_expectancy"]))
N=dim(gapminder.QRD)[1]

# echantillon de taille 20 
n=20
set.seed(123456)
index = sample(1:N,n, replace=FALSE)
ech = gapminder.QRD[index,c("life_expectancy","lgdppc")]
(y.bar = mean(ech$life_expectancy))
(x.bar = mean(ech$lgdppc))

# quantites intermédiaires
(somme.xi = sum(ech$lgdppc))
(somme.yi = sum(ech$life_expectancy))
(somme.xi.2 = sum(ech$lgdppc^2))
(somme.yi.2 = sum(ech$life_expectancy^2))
(somme.xiyi = sum(ech$lgdppc*ech$life_expectancy))

s2.X = (somme.xi.2-n*x.bar^2)/(n-1)
s2.Y = (somme.yi.2-n*y.bar^2)/(n-1)
s.XY = (somme.xiyi-n*x.bar*y.bar)/(n-1)

# coefficient de correlation
(rho = s.XY/sqrt(s2.X*s2.Y))

# EQM (MSE)
(s2.W.L = (n-1)/(n-2)*s2.Y*(1-rho^2))

# marge d'erreur
(B = 2*sqrt(s2.W.L/n*(1-n/N)))

# estime ponctuel
(hat.mu.Y.L = y.bar + rho*sqrt(s2.Y/s2.X)*(mu.X-x.bar))

# intervalle de confiance
hat.mu.Y.L-B
hat.mu.Y.L+B

# en utilisant la fonction lm() 
reg.lin = lm(life_expectancy~lgdppc, data=ech)
summary(reg.lin)
(b = as.numeric(reg.lin$coefficients[2]))
(s2.W.L = summary(reg.lin)$sigma^2)


####### Population Difference
(mu.X = mean(gapminder.QRD[,"lgdppc"]))
(mu.Y = mean(gapminder.QRD[,"life_expectancy"]))
N=dim(gapminder.QRD)[1]

# echantillon de taille 20 
n=20
set.seed(1234567)
index = sample(1:N,n, replace=FALSE)
ech = gapminder.QRD[index,c("life_expectancy","lgdppc")]
d = ech$life_expectancy - ech$lgdppc

# quantites intermédiaires
(y.bar = mean(ech$life_expectancy))
(x.bar = mean(ech$lgdppc))
(d.bar = mean(d))
(s2.d = var(d))

# marge d'erreur
(B = 2*sqrt(s2.d/n*(1-n/N)))

# estime ponctuel
(hat.mu.Y.D = y.bar + (mu.X-x.bar))

# intervalle de confiance
hat.mu.Y.D-B
hat.mu.Y.D+B
